#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [Teleport]",
	author	= "wS",
	version = "1.2.1"
};

#define ITEM_NAME "teleport"

new g_TpCount[MAXPLAYERS + 1][2]; // 0 = разрешено телепортироваться 'x' раз, 1 = осталось телепортов
new Float:g_fLastTpTime[MAXPLAYERS + 1];
new Handle:g_hCvarTpModel, String:g_sTpModel[128],g_EffectIndex;
new Handle:g_hCvarTpSound, String:g_sTpSound[128];
new Float:g_fDistMin, Float:g_fDistMax, Float:g_fTpDelay, g_Msg;

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_SELECT))
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);

	LoadTranslations("vip_teleport.phrases");
	RegConsoleCmd( "sm_tp", TpCmd);
	VIP_HookEvent(VE_Spawn, OnClientSpawn);

	//
	g_hCvarTpModel		= CreateConVar("vip_teleport_sprite",	"materials/sprites/glow04.vmt",					"0 = disable effect");
	g_hCvarTpSound		= CreateConVar("vip_teleport_sound",	"physics/plastic/plastic_barrel_break2.wav",	"0 = disable sound");

	new Handle:hCvar	= CreateConVar("vip_teleport_dist_min",	"100",											"Minimum distanse for teleport (units) (0 = disable)");
	g_fDistMin			= GetConVarFloat(hCvar);
	HookConVarChange(hCvar, CvarChanged);

	hCvar				= CreateConVar("vip_teleport_dist_max",	"0",											"Maximum distanse for teleport (units) (0 = disable)");
	g_fDistMax			= GetConVarFloat(hCvar);
	HookConVarChange(hCvar, CvarChanged);

	hCvar				= CreateConVar("vip_teleport_delay",	"1.0",											"Delay before next teleport (0 = disable)");
	g_fTpDelay			= GetConVarFloat(hCvar);
	HookConVarChange(hCvar, CvarChanged);

	hCvar				= CreateConVar("vip_teleport_msg",		"1",											"1 = center message | 2 = hint | 3 = chat (0 = disable)", _, true, 0.0, true, 3.0);
	g_Msg				= GetConVarInt(hCvar);
	HookConVarChange(hCvar, CvarChanged);

	AutoExecConfig(true, "teleport", "vip/modules/teleport");
	//
}

public CvarChanged(Handle:hCvar, const String:OldValue[], const String:NewValue[])
{
	decl String:CvarName[32];
	GetConVarName(hCvar, CvarName, sizeof(CvarName));
	strcopy(CvarName, sizeof(CvarName), CvarName[13]);
	if (	 !strcmp(CvarName, "dist_min",	false)) g_fDistMin	= StringToFloat(NewValue);
	else if (!strcmp(CvarName, "dist_max",	false)) g_fDistMax	= StringToFloat(NewValue);
	else if (!strcmp(CvarName, "delay",		false)) g_fTpDelay	= StringToFloat(NewValue);
	else if (!strcmp(CvarName, "msg",		false)) g_Msg		= StringToInt(NewValue);
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_TpCount[client][0])
	{
		IntToString(g_TpCount[client][0], ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	return UpdateAccess(client, ItemValue);
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	g_TpCount[client][0] = 0;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, false);
}

stock VipGiveAction:UpdateAccess(client, String:ItemValue[ITEM_INFO_LENGTH])
{
	if (!ItemValue[0])
		return VGA_ValueNotSpecified;

	new value = StringToInt(ItemValue);
	if (value < 1)
		return VGA_BadValue;

	if (value == g_TpCount[client][0])
		return VGA_SameValue;
	
	g_TpCount[client][0] = value;

	IntToString(g_TpCount[client][0], ItemValue, ITEM_INFO_LENGTH);
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, true, ItemValue, 16);

	return VGA_Continue;
}

///////////////////////////////////////////////////////////////////////////////////

public OnConfigsExecuted()
{
	wS_GetSoundFromCvar(g_hCvarTpSound, g_sTpSound, sizeof(g_sTpSound));
	
	GetConVarString(g_hCvarTpModel, g_sTpModel, sizeof(g_sTpModel));
	g_EffectIndex = mdl(g_sTpModel, sizeof(g_sTpModel), false) ? PrecacheModel(g_sTpModel) : -1;
}

public OnClientSpawn(client, team)
{
	g_TpCount[client][1]  = g_TpCount[client][0];
	g_fLastTpTime[client] = 0.0;
}

public OnClientDisconnect(client)
{
	g_TpCount[client][0]  = 0;
	g_TpCount[client][1]  = 0;
	g_fLastTpTime[client] = 0.0;
}

//

public Action:TpCmd(client, args)
{
	if (client < 1 || !IsPlayerAlive(client))
		return Plugin_Handled;

	if (g_TpCount[client][0] < 1)
	{
		PrintToChat(client, "%t", "NoAccess");
		return Plugin_Handled;
	}

	if (g_TpCount[client][1] < 1)
	{
		PrintToChat(client, "%t", "NextRound");
		return Plugin_Handled;
	}

	new Float:fCurrSec = GetGameTime();
	if (g_fTpDelay > 0.0 && (fCurrSec - g_fLastTpTime[client]) < g_fTpDelay)
	{
		PrintToChat(client, "%t", "wait", Float:(g_fTpDelay - (fCurrSec - g_fLastTpTime[client])));
		return Plugin_Handled;
	}

	decl Float:angles[3];
	if (!GetClientEyeAngles(client, angles))
		return Plugin_Handled;

	decl Float:v[3];
	GetClientEyePosition(client, v);
	TR_TraceRayFilter(v, angles, MASK_PLAYERSOLID, RayType_Infinite, tp_filter, client);
	if (!TR_DidHit())
		return Plugin_Handled;

	decl Float:EndPos[3];
	TR_GetEndPosition(EndPos);

	if (g_fDistMin > 0.0 || g_fDistMax > 0.0)
	{
		new Float:fDist = GetVectorDistance(v, EndPos);
		if (g_fDistMin > 0.0 && fDist < g_fDistMin)
		{
			PrintToChat(client, "%t", "min");
			return Plugin_Handled;
		}
		if (g_fDistMax > 0.0 && fDist > g_fDistMax)
		{
			PrintToChat(client, "%t", "max");
			return Plugin_Handled;
		}
	}

	g_fLastTpTime[client] = fCurrSec;
	g_TpCount[client][1]--;

	TR_GetPlaneNormal(INVALID_HANDLE, v);
	GetVectorAngles(v, angles);

	EndPos[0] += v[0] * 35.0;
	EndPos[1] += v[1] * 35.0;
	if (angles[0] == 90.0 && angles[1] == 0.0 && angles[2] == 0.0) EndPos[2] -= 75.0;
	else EndPos[2] += 10.0;

	TeleportEntity(client, EndPos, NULL_VECTOR, NULL_VECTOR);

	if (g_EffectIndex > 0)
	{
		EndPos[2] += 35.0;
		TE_SetupGlowSprite(EndPos, g_EffectIndex, 0.1, 3.0, 255);
		TE_SendToAll();
	}

	if (g_sTpSound[0] != 0)
		EmitAmbientSound(g_sTpSound, NULL_VECTOR, client, _, _, 1.0);

	if (g_Msg > 0)
	{
		if (g_Msg == 1) PrintCenterText(client, "%t", "tp", g_TpCount[client][1]);
		else if (g_Msg == 2) PrintHintText(client, "%t", "tp", g_TpCount[client][1]);
		else PrintToChat(client, "%t", "tp", g_TpCount[client][1]);
	}

	return Plugin_Handled;
}

public bool:tp_filter(TraceEnt, mask, any:entity)
{
	return TraceEnt != entity;
}

stock wS_GetSoundFromCvar(Handle:hCvar, String:sound[], size)
{
	decl index;
	GetConVarString(hCvar, sound, size);
	if (TrimString(sound) > 4 && (index = FindCharInString(sound, '.', true)) > 0 && (!strcmp(sound[index + 1], "mp3", false) || !strcmp(sound[index + 1], "wav", false)))
	{
		ReplaceString(sound, size, "\\", "/");

		if (StrContains(sound, "sound/", false) != 0) Format(sound, size, "sound/%s", sound);
		AddFileToDownloadsTable(sound);

		if (GetEngineVersion() == Engine_CSGO)
		{
			Format(sound, size, "*%s", sound[6]);
			static x = INVALID_STRING_TABLE;
			if (x != INVALID_STRING_TABLE || (x = FindStringTable("soundprecache")) != INVALID_STRING_TABLE)
				AddToStringTable(x, sound);
			else
			{
				sound[0] = 0;
				LogError("FindStringTable soundprecache error");
			}
		}
		else
		{
			strcopy(sound, size, sound[6]);
			PrecacheSound(sound);
		}
	}
	else
		sound[0] = 0;
}

stock bool:mdl(String:path[], size, bool:bPrecache = false)
{
	if (!path[0] || TrimString(path) < 11 || StrContains(path, "models", false) != 0) return false;
	new i = FindCharInString(path, '.', true);
	if (i > 6 && !strcmp(path[i + 1], "mdl", false))
	{
		ReplaceString(path, size, "\\", "/");
		if (bPrecache) PrecacheModel(path, true);
		return true;
	}
	path[0] = 0;
	return false;
}

public VIP_MenuSelect(client, ItemID, const String:ItemName[], const String:ItemValue[])
{
	new Handle:panel = CreatePanel();
	decl String:text[512];
	FormatEx(text, 512, "%T\n \n", "info", client, g_TpCount[client][0]);
	ReplaceString(text, 512, "\\n", "\n");
	DrawPanelText(panel, text);
	SetPanelCurrentKey(panel, 8);
	DrawPanelItem(panel, "<-");
	SetPanelCurrentKey(panel, VIP_GetServerType() == 1 ? 9 : 10);
	DrawPanelItem(panel, "Exit");
	SendPanelToClient(panel, client, panel_CallBack, 0);
	CloseHandle(panel);
}

public panel_CallBack(Handle:panel, MenuAction:action, client, item)
{
	if (action == MenuAction_Select && item == 8 && !VIP_MenuFlood(client)) {
		VIP_ShowMenu(client);
	}
}